/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2017 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.jannot.alignment.maf;

import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import net.sf.jannot.Data;
import net.sf.jannot.MemoryListData;

/**
 * @author Thomas Abeel
 * 
 */
public class MAFMemoryMultipleAlignment extends AbstractMAFMultipleAlignment {

	private MemoryListData<AbstractAlignmentBlock> delegate;

	public MAFMemoryMultipleAlignment() {
		final Data<AbstractAlignmentBlock> _self = this;
		delegate = new MemoryListData<AbstractAlignmentBlock>() {

			@Override
			public String label() {
				return _self.label();
			}

		};
	}

	@Override
	public Iterable<AbstractAlignmentBlock> get(int start, int end){
		return delegate.get(start, end);
	}

	@Override
	public Iterable<AbstractAlignmentBlock> get(){
		return delegate.get();
		
	}

	public void add(MemoryAlignmentBlock a) {
		delegate.add(a);
		
	}

	@Override
	public int noAlignmentBlocks() {
		return delegate.size();
	}


}
